> For the complete documentation index, see [llms.txt](https://docs.boii.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.boii.dev/fivem-free-resources/bdsc/api/registry.md).

# Registry

The player registry handles the creation, tracking, and lifecycle of all active player objects in BDSC.

It provides functions to:

* Create and register new players
* Access and remove player objects
* Save player state
* Retrieve client-side replicated data

This system is core to how BDSC manages players internally. \
Use these functions to safely access and interact with player objects.

***

## Server

***

Creates and registers a player object from a source ID.

#### Parameters

* `source`: `number`

#### Returns

* `boolean`

```lua
bdsc.create_player(source)
```

***

### add\_player

Adds a player object to the internal registry.\
Realistically this should never need to be called externally, this is handled internally on object creation.

#### Parameters

* `player`: `table`&#x20;

#### Returns

* `boolean`

```lua
bdsc.add_player(player)
```

***

### remove\_player

Removes a player from the internal registry.

#### Parameters

* `source`: `number`

#### Returns

* `boolean`

```lua
bdsc.remove_player(source)
```

***

### get\_players

Retrieves all currently registered players.

#### Returns

* `table`

```lua
local all_players = bdsc.get_players()
```

***

### get\_player

Retrieves a specific player object from the registry.

#### Parameters

* `source`: `number`

#### Returns

* `table|nil`

```lua
local player = bdsc.get_player(source)
```

***

### save\_players

Calls `:save()`

```lua
bdsc.save_players()
```

***

## Client

***

### get\_player\_data

Retrieves replicated client-side player data.

#### Returns

* `table`

```lua
local data = bdsc.get_player_data()
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.boii.dev/fivem-free-resources/bdsc/api/registry.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
